package com.jamieswhiteshirt.reachentityattributes.mixin.client;

import com.jamieswhiteshirt.reachentityattributes.ReachEntityAttributes;
import com.llamalad7.mixinextras.injector.ModifyExpressionValue;
import net.minecraft.class_310;
import net.minecraft.class_636;
import org.spongepowered.asm.mixin.Final;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;

@Mixin(class_636.class)
abstract class ClientPlayerInteractionManagerMixin {
    @Shadow @Final private class_310 client;

    @ModifyExpressionValue(
        method = "getReachDistance",
        at = @At(value = "INVOKE", target = "Lnet/minecraft/entity/player/PlayerEntity;getReachDistance(Z)F"))
    private float getActualReachDistance(float original) {
        if (this.client.field_1724 != null) {
            return (float) ReachEntityAttributes.getReachDistance(this.client.field_1724, original);
        }
        return original;
    }
}
